commit:     2ad8bd5161e9eafeb37f46c9a9e321903a1797e0
Author:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
AuthorDate: Thu Jul 30 08:51:59 2020 +0000
Commit:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
CommitDate: Thu Jul 30 08:52:33 2020 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=2ad8bd51

Revert "sys-libs/readline: Security cleanup (drop <8)"

This reverts commit 2280012d7e09b97fb7441ea8c2b353f30a6ed356.
because it breaks app-admin/puppet-agent and dev-lisp/clisp

Bug: https://bugs.gentoo.org/717924
Signed-off-by: Lars Wendler <polynomial-c <AT> gentoo.org>

 sys-libs/readline/Manifest                         |  15 ++
 .../readline-6.3-fix-long-prompt-vi-search.patch   |  26 +++
 .../readline/files/readline-6.3-read-eof.patch     |  54 +++++++
 sys-libs/readline/files/readline-7.0-mingw.patch   | 152 ++++++++++++++++++
 .../files/readline-7.0-missing-echo-proto.patch    |  14 ++
 sys-libs/readline/readline-6.3_p8-r3.ebuild        | 163 +++++++++++++++++++
 sys-libs/readline/readline-7.0_p5-r1.ebuild        | 174 +++++++++++++++++++++
 7 files changed, 598 insertions(+)

diff --git a/sys-libs/readline/Manifest b/sys-libs/readline/Manifest
index 8dd67c3a4d8..030cef77bba 100644
--- a/sys-libs/readline/Manifest
+++ b/sys-libs/readline/Manifest
@@ -1,4 +1,19 @@
+DIST readline-6.3.tar.gz 2468560 BLAKE2B 
24488ec141734c050ba985a93423692396f105619bae3ce5b109bc68a4f43862bcf3a6fb8d82fec1145d665cdb408765e179379bb35f008d09c441fa2e5739df
 SHA512 
f70efaf46d570b85c7637172b0ee2eb9a4aa73ba38a62bb45075e665929d9701b96fba0aea6c767fd9a2a0d39dfe8e70ab06da08f8524aee76a7c502f370a401
+DIST readline-7.0.tar.gz 2910016 BLAKE2B 
679b8aa7ce003017b729e6d8d4cb69d0f991578441a3e69005090079e61f6aa48b7ad4d0b1f34b6041528cf33254a1bf3ddb05b60db53a06e443d7922d49d0d4
 SHA512 
18243189d39bf0d4c8a76cddcce75243c1bae8824c686e9b6ba352667607e5b10c5feb79372a1093c1c388d821841670702e940df12eae94bcebdeed90047870
 DIST readline-8.0.tar.gz 2975937 BLAKE2B 
95e08b28cc46582f036379413810ca40c97d4d3bc59a9e03e04e57d531573abfbe955f6f1cb86e39c208bf6c3f4c618cff70a87bec596d0b9120909d6c5a2f69
 SHA512 
41759d27bc3a258fefd7f4ff3277fa6ab9c21abb7b160e1a75aa8eba547bd90b288514e76264bd94fb0172da8a4faa54aab2c07b68a0356918ecf7f1969e866f
+DIST readline63-001 1366 BLAKE2B 
82af5be99597719329db3f1d6049e75a5654ccf6597cf557c71ad7ada0ac03be87381a7738931eb78716de65902ae87498f574b84150a69eae9cc308c4bfffdd
 SHA512 
e70f89ca52a4eae7e1cddd70de6a7162252231ee029c89bb3fcb0f6c8c8b46c666be910c8b2eee72e96983ec2f1a23663694dc222f67228d82e8e4684f1504a2
+DIST readline63-002 1297 BLAKE2B 
5ace4a81381910ee48dee8cdbb2ca95a1bef2d1f8acca6d39a910c078c86de10a0fc29486939b336110ecb0281b3edb16e4b985f41e7ee161904728f289fff04
 SHA512 
4e23bd67433577e6e361d10a6c32768ea9e13b10e77493e565b870f56069b673fbcb0b860225f79fa9931845fc91d35c9a82c1385c23f8b757ebfd59f27851f4
+DIST readline63-003 985 BLAKE2B 
cf2cda505b100d5f820d8bfc99eed6b50e65c92b6a495073352fc7385c6456478594e5c2dc293ce556b66853dff705050fb97982aa25fce452ae53d2cb272cf4
 SHA512 
6bfb84a5b980091b995e2b96bdf5680f97fe670e6cac1b8606d2d75a1ef922ff5bd4e73f029f7af98a115006b7ab7828146f2cd6986287543d8a29987c91dc12
+DIST readline63-004 1363 BLAKE2B 
c1aec93f1e23acd51b36068d3aac31b93ffd9c1039be2c45ff4e6479135f153888030c68cf19c5ced950f6fbbb38ee7fa644d5a737f3f8ed511e97bf342940f5
 SHA512 
6b683e9fe28831885135391b5a23bc580cacf0ffe720951a80f545574eda4eb064fe189801d44329b2eb2d3577db5a90f9e5ad9ed131e7e8a8ae349511632721
+DIST readline63-005 1664 BLAKE2B 
f98f62be8676aca81b91d919bc4eccfe40c382a8baab0e64b1659b714f0d72424e29b709cc5e226fd73daf67eef264a17e07982d2553ce80f5e5f39fad70610b
 SHA512 
b0332d7f999376788155341319d138a899a2278c338a6faaac89ecf3ed1e2248a07413dd810a76996bf25f211de787182b55f34ab3d7d31eb7519d7a48ebed32
+DIST readline63-006 1982 BLAKE2B 
ad6d16ff769eb8e367cf961ffe152c04778b046a04e4a62e0ce21d08fa16b0eca3d278dbdc274b082d24fa2ec959ffb62168ea7693b4de94b59a4526b1f0c4a2
 SHA512 
e9fbfa38d7b03ab2aff2e9e48918b85b4b67a729862ee47d1cc8e0aeb90c3224394a79f68829951e1377cae65742aa5385eae865f75e9c0b2e2abde42889431c
+DIST readline63-007 1428 BLAKE2B 
60e64c2dd36457e3992cfbfbbcc261337e515be360a37d71b9de236c62c781f10f0ec37e4e196b4634e5d547edebbf915370091ca42fff873b78cd80cfe3a7f2
 SHA512 
abee331894846b360203a521d9a66fa02c03214120d5cafbd1cb4d680bd7bbef14321ae845dd67f7b5e8c87322801fd96fc9a5fd0ae026b41d98dc24a8949854
+DIST readline63-008 1452 BLAKE2B 
4e41c45be1479fba9f74bf9cedb8d1f6237e650962d5b45ea1a61cc48a8323a0fa60d76f68c011b6e7c73a1078b5ff80f9966e983b994f814d471d0efd9efde6
 SHA512 
8e30bbca3aa5cea8c2ee511abe0ec8f131608d74fe5ab24d68bcf452267f0f97446ed6e7cd482360876ce6c027280e4f4450cae05eb18f56046240f4c224841c
+DIST readline70-001 1777 BLAKE2B 
ab217bd9d27f30351397db2b745cb33ac7e0ce18bbc00112bb87570da0f62ee0e8d182395c97e4ecc21af51e7e1e580ba48076de1095c556f0744475e4019821
 SHA512 
4402186905af8cd42c609d640c2e13b9ad61c7778e5a3fd2c2d9da301f0deab05b04d7836f31527262f44f406517823dbb18cb07f2c73931186c806b494699ec
+DIST readline70-002 2953 BLAKE2B 
47d729b1babe904855fe5d4f780a5b2153a743def527479c3cb82759cdee5bb4260be722e1050be680f5c0dd6dec8ca25c4c1ff557415abae6b3fac2bd481f0b
 SHA512 
13d1489578508d4d2c3a1618024198a709dbce74a6bbf0f6d7ec67d2419c55bfec9f0ca9de0ed93f129d21d5c3a94307ccdc49408455bbb301c5e3a772b03185
+DIST readline70-003 1294 BLAKE2B 
9473e18b582fba69cea83e3f5b9fa278dd8b0544325439307d2b4053cbeca8d2f008104bee181ae5d9405d702e6d3bcf26379c4d46e269906474c8544367b780
 SHA512 
eaf962a1480eb3870519017b81ecc5cef171e4c41fcf8c17da61ccbfd0379ed6bca85c17b03e2207ae4d51509f33fd010294c75f4bd0433a52118015d4160385
+DIST readline70-004 1501 BLAKE2B 
cebce69a21bee3a4d6a908de09f371d65eab6af51a8dc0f58fc915b916957db420252ce07b06703c05d984f62e1e849b6975f5444b2af6ba35ff7c939acf9d99
 SHA512 
7be41558eab3b88a3657f8589ecfaff0b8ee7f59083d385f50e8704fe830e05a50652a5feda19ff1f3cfd98bff4bb8e25e1637ec4dac8a618db9c8220a3d954e
+DIST readline70-005 1641 BLAKE2B 
f720508f698b113c6328018f7e6e8775c7c79afc464047405a5c3dae017d611535017dfc2759c11483bb536fab1e9bf72c7a9d3c769b7aea3bd2cee9686bd522
 SHA512 
eeb27f4f9195cb905d5891f26480d58f59c885dde3457f7a30ff57760ac772e2333ee8aeae979214949f3b52030285b10db013e307ee7311abab677a4427e878
 DIST readline80-001 927 BLAKE2B 
95e3ac33ff4adb65813274864c17781056a8ea065f9a76571b4a6bcb2ebab090c3a021fa2b621832c11b5995e48a8a26dd6e3a8f5864a8e8b520bfcf85d7c4ab
 SHA512 
a148cda6ac97935d51ede1bbacf847d7d2cba8861cf3941d32e3da2f45f16dcc05b20845b63d4264692520db8329e1236cf2bc4fd8ccbe6e40921bbbdeb2cb1c
 DIST readline80-002 1401 BLAKE2B 
a2f511272f6d651208469998330059d6bae17bb8b704b64468685bb0368b76df1ca5b1dcd8e5cb0019e80932130c8a92fd1a305679bf79f0b801532a94c4b4ae
 SHA512 
a941d142a59fe592cc45c1cf4d416e2fc0ab543dd6a0496fb8b2ec6f651cedd6fb9e0c105f14880700b69b2d6912653b3f66371e45cbe4adc0cc9554801afd3c
 DIST readline80-003 2158 BLAKE2B 
d8910aef1b796a59500b255df8db71ad1738dd164fd69827759eade74b6d9806ecd364839cfa904fc2f2d48352342155f670e5ec43aac0693f36820fb7139a4d
 SHA512 
85235fca047b4ac87b846d998fffc67ae67ed365b068fd2743e84f11fd00086f85e622955192e07e3560965e32ff5f6d014e0146cde528fb0d0f7b5b829875ca

diff --git 
a/sys-libs/readline/files/readline-6.3-fix-long-prompt-vi-search.patch 
b/sys-libs/readline/files/readline-6.3-fix-long-prompt-vi-search.patch
new file mode 100644
index 00000000000..23d785054e7
--- /dev/null
+++ b/sys-libs/readline/files/readline-6.3-fix-long-prompt-vi-search.patch
@@ -0,0 +1,26 @@
+https://lists.gnu.org/archive/html/bug-bash/2014-08/msg00082.html
+
+From 2774192e93991e3d85ccc37c714aa018e442af6d Mon Sep 17 00:00:00 2001
+From: Dylan Cali <[email protected]>
+Date: Sat, 23 Aug 2014 02:26:05 -0500
+Subject: [PATCH] fix vi search prompt bug for long prompts
+
+---
+ display.c |    2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/display.c b/display.c
+index 4df1f73..e575b16 100644
+--- a/display.c
++++ b/display.c
+@@ -2259,7 +2259,7 @@ rl_message (va_alist)
+       va_start (args);
+       format = va_arg (args, char *);
+ #endif
+-      vsnprintf (msg_buf, msg_bufsiz - 1, format, args);
++      vsnprintf (msg_buf, msg_bufsiz, format, args);
+     }
+ #else
+   vsprintf (msg_buf, format, args);
+-- 
+1.7.10.4

diff --git a/sys-libs/readline/files/readline-6.3-read-eof.patch 
b/sys-libs/readline/files/readline-6.3-read-eof.patch
new file mode 100644
index 00000000000..f74aad63be1
--- /dev/null
+++ b/sys-libs/readline/files/readline-6.3-read-eof.patch
@@ -0,0 +1,54 @@
+http://lists.gnu.org/archive/html/bug-bash/2014-12/msg00152.html
+
+*** ../bash-4.3-patched/lib/readline/readline.c        2014-10-01 
13:08:28.000000000 -0400
+--- lib/readline/readline.c    2014-12-20 22:37:28.000000000 -0500
+***************
+*** 580,592 ****
+       }
+  
+!       /* EOF typed to a non-blank line is a <NL>.  If we want to change this,
+!       to force any existing line to be ignored when read(2) reads EOF,
+!       for example, this is the place to change. */
+        if (c == EOF && rl_end)
+!      c = NEWLINE;
+  
+        /* The character _rl_eof_char typed to blank line, and not as the
+!       previous character is interpreted as EOF. */
+!       if (((c == _rl_eof_char && lastc != c) || c == EOF) && !rl_end)
+       {
+  #if defined (READLINE_CALLBACKS)
+--- 587,620 ----
+       }
+  
+!       /* EOF typed to a non-blank line is ^D the first time, EOF the second
+!       time in a row.  This won't return any partial line read from the tty.
+!       If we want to change this, to force any existing line to be returned
+!       when read(2) reads EOF, for example, this is the place to change. */
+        if (c == EOF && rl_end)
+!      {
+!        if (RL_SIG_RECEIVED ())
+!          {
+!            RL_CHECK_SIGNALS ();
+!            if (rl_signal_event_hook)
+!              (*rl_signal_event_hook) ();             /* XXX */
+!          }
+! 
+!        /* XXX - reading two consecutive EOFs returns EOF */
+!        if (RL_ISSTATE (RL_STATE_TERMPREPPED))
+!          {
+!            if (lastc == _rl_eof_char || lastc == EOF)
+!              rl_end = 0;
+!            else
+!              c = _rl_eof_char;
+!          }
+!        else
+!          c = NEWLINE;
+!      }
+  
+        /* The character _rl_eof_char typed to blank line, and not as the
+!       previous character is interpreted as EOF.  This doesn't work when
+!       READLINE_CALLBACKS is defined, so hitting a series of ^Ds will
+!       erase all the chars on the line and then return EOF. */
+!       if (((c == _rl_eof_char && lastc != c) || c == EOF) && rl_end == 0)
+       {
+  #if defined (READLINE_CALLBACKS)

diff --git a/sys-libs/readline/files/readline-7.0-mingw.patch 
b/sys-libs/readline/files/readline-7.0-mingw.patch
new file mode 100644
index 00000000000..f003038d2c0
--- /dev/null
+++ b/sys-libs/readline/files/readline-7.0-mingw.patch
@@ -0,0 +1,152 @@
+--- a/colors.c
++++ b/colors.c
+@@ -37,6 +37,10 @@
+ #include "posixstat.h" // stat related macros (S_ISREG, ...)
+ #include <fcntl.h> // S_ISUID
+ 
++#ifndef S_ISDIR
++#define       S_ISDIR(m)      (((m) & S_IFMT) == S_IFDIR)
++#endif
++
+ // strlen()
+ #if defined (HAVE_STRING_H)
+ #  include <string.h>
+@@ -182,12 +186,17 @@ _rl_print_color_indicator (const char *f
+       if (S_ISREG (mode))
+         {
+           colored_filetype = C_FILE;
+-
++#ifdef S_ISUID
+           if ((mode & S_ISUID) != 0 && is_colored (C_SETUID))
+             colored_filetype = C_SETUID;
+-          else if ((mode & S_ISGID) != 0 && is_colored (C_SETGID))
++              else
++#endif
++#ifdef S_ISGID
++          if ((mode & S_ISGID) != 0 && is_colored (C_SETGID))
+             colored_filetype = C_SETGID;
+-          else if (is_colored (C_CAP) && 0) //f->has_capability)
++          else
++#endif
++                if (is_colored (C_CAP) && 0) //f->has_capability)
+             colored_filetype = C_CAP;
+           else if ((mode & S_IXUGO) != 0 && is_colored (C_EXEC))
+             colored_filetype = C_EXEC;
+@@ -211,12 +220,16 @@ _rl_print_color_indicator (const char *f
+             colored_filetype = C_STICKY;
+ #endif
+         }
++#if defined (S_ISLNK)
+       else if (S_ISLNK (mode))
+         colored_filetype = C_LINK;
++#endif
+       else if (S_ISFIFO (mode))
+         colored_filetype = C_FIFO;
++#if defined (S_ISSOCK)
+       else if (S_ISSOCK (mode))
+         colored_filetype = C_SOCK;
++#endif
+       else if (S_ISBLK (mode))
+         colored_filetype = C_BLK;
+       else if (S_ISCHR (mode))
+--- a/histfile.c
++++ b/histfile.c
+@@ -606,12 +606,14 @@ history_truncate_file (fname, lines)
+       history_lines_written_to_file = 0;
+     }
+ 
++#if defined (HAVE_CHOWN)
+   /* Make sure the new filename is owned by the same user as the old.  If one
+      user is running this, it's a no-op.  If the shell is running after sudo
+      with a shared history file, we don't want to leave the history file
+      owned by root. */
+   if (rv == 0 && exists)
+     r = chown (filename, finfo.st_uid, finfo.st_gid);
++#endif
+ 
+   xfree (filename);
+   FREE (tempname);
+@@ -753,12 +755,14 @@ mmap_error:
+       history_lines_written_to_file = 0;
+     }
+ 
++#if defined (HAVE_CHOWN)
+   /* Make sure the new filename is owned by the same user as the old.  If one
+      user is running this, it's a no-op.  If the shell is running after sudo
+      with a shared history file, we don't want to leave the history file
+      owned by root. */
+   if (rv == 0 && exists)
+     mode = chown (histname, finfo.st_uid, finfo.st_gid);
++#endif
+ 
+   FREE (histname);
+   FREE (tempname);
+--- a/input.c
++++ b/input.c
+@@ -71,6 +71,10 @@ extern int errno;
+ #include "rlshell.h"
+ #include "xmalloc.h"
+ 
++#if defined (__MINGW32__)
++#include <conio.h>
++#endif
++
+ /* What kind of non-blocking I/O do we have? */
+ #if !defined (O_NDELAY) && defined (O_NONBLOCK)
+ #  define O_NDELAY O_NONBLOCK /* Posix style */
+--- a/posixstat.h
++++ b/posixstat.h
+@@ -78,30 +78,44 @@
+ 
+ #if defined (S_IFBLK) && !defined (S_ISBLK)
+ #define       S_ISBLK(m)      (((m)&S_IFMT) == S_IFBLK)       /* block device 
*/
++#elif !defined (S_IFBLK)
++#define S_ISBLK(m) 0
+ #endif
+ 
+ #if defined (S_IFCHR) && !defined (S_ISCHR)
+ #define       S_ISCHR(m)      (((m)&S_IFMT) == S_IFCHR)       /* character 
device */
++#elif !defined (S_IFCHR)
++#define S_ISCHR(m) 0
+ #endif
+ 
+ #if defined (S_IFDIR) && !defined (S_ISDIR)
+ #define       S_ISDIR(m)      (((m)&S_IFMT) == S_IFDIR)       /* directory */
++#elif !defined (S_IFDIR)
++#define S_ISDIR(m) 0
+ #endif
+ 
+ #if defined (S_IFREG) && !defined (S_ISREG)
+ #define       S_ISREG(m)      (((m)&S_IFMT) == S_IFREG)       /* file */
++#elif !defined (S_IFREG)
++#define S_ISREG(m) 0
+ #endif
+ 
+ #if defined (S_IFIFO) && !defined (S_ISFIFO)
+ #define       S_ISFIFO(m)     (((m)&S_IFMT) == S_IFIFO)       /* fifo - named 
pipe */
++#elif !defined (S_IFIFO)
++#define S_ISFIFO(m) 0
+ #endif
+ 
+ #if defined (S_IFLNK) && !defined (S_ISLNK)
+ #define       S_ISLNK(m)      (((m)&S_IFMT) == S_IFLNK)       /* symbolic 
link */
++#elif !defined (S_IFLNK)
++#define S_ISLNK(m) 0
+ #endif
+ 
+ #if defined (S_IFSOCK) && !defined (S_ISSOCK)
+ #define       S_ISSOCK(m)     (((m)&S_IFMT) == S_IFSOCK)      /* socket */
++#elif !defined (S_IFSOCK)
++#define S_ISSOCK(m) 0
+ #endif
+ 
+ /*
+@@ -137,6 +151,8 @@
+ /* These are non-standard, but are used in builtins.c$symbolic_umask() */
+ #define S_IRUGO               (S_IRUSR | S_IRGRP | S_IROTH)
+ #define S_IWUGO               (S_IWUSR | S_IWGRP | S_IWOTH)
++#if defined(S_IXUSR) && defined(S_IXOTH)
+ #define S_IXUGO               (S_IXUSR | S_IXGRP | S_IXOTH)
++#endif
+ 
+ #endif /* _POSIXSTAT_H_ */

diff --git a/sys-libs/readline/files/readline-7.0-missing-echo-proto.patch 
b/sys-libs/readline/files/readline-7.0-missing-echo-proto.patch
new file mode 100644
index 00000000000..cad3c8ca2c4
--- /dev/null
+++ b/sys-libs/readline/files/readline-7.0-missing-echo-proto.patch
@@ -0,0 +1,14 @@
+https://lists.gnu.org/archive/html/bug-readline/2016-11/msg00000.html
+
+fix from upstream
+
+--- a/readline.h
++++ b/readline.h
+@@ -413,6 +413,7 @@
+ extern void rl_tty_set_default_bindings PARAMS((Keymap));
+ extern void rl_tty_unset_default_bindings PARAMS((Keymap));
+ 
++extern int rl_tty_set_echoing PARAMS((int));
+ extern int rl_reset_terminal PARAMS((const char *));
+ extern void rl_resize_terminal PARAMS((void));
+ extern void rl_set_screen_size PARAMS((int, int));

diff --git a/sys-libs/readline/readline-6.3_p8-r3.ebuild 
b/sys-libs/readline/readline-6.3_p8-r3.ebuild
new file mode 100644
index 00000000000..009f74e037f
--- /dev/null
+++ b/sys-libs/readline/readline-6.3_p8-r3.ebuild
@@ -0,0 +1,163 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=5
+
+inherit eutils multilib toolchain-funcs flag-o-matic multilib-minimal 
preserve-libs usr-ldscript
+
+# Official patches
+# See ftp://ftp.cwru.edu/pub/bash/readline-6.3-patches/
+PLEVEL=${PV##*_p}
+MY_PV=${PV/_p*}
+MY_PV=${MY_PV/_/-}
+MY_P=${PN}-${MY_PV}
+[[ ${PV} != *_p* ]] && PLEVEL=0
+patches() {
+       [[ ${PLEVEL} -eq 0 ]] && return 1
+       local opt=$1
+       eval set -- {1..${PLEVEL}}
+       set -- $(printf "${PN}${MY_PV/\.}-%03d " "$@")
+       if [[ ${opt} == -s ]] ; then
+               echo "${@/#/${DISTDIR}/}"
+       else
+               local u
+               for u in ftp://ftp.cwru.edu/pub/bash mirror://gnu/${PN} ; do
+                       printf "${u}/${PN}-${MY_PV}-patches/%s " "$@"
+               done
+       fi
+}
+
+DESCRIPTION="Another cute console display library"
+HOMEPAGE="https://tiswww.case.edu/php/chet/readline/rltop.html";
+SRC_URI="mirror://gnu/${PN}/${MY_P}.tar.gz $(patches)"
+
+LICENSE="GPL-3"
+SLOT="0"
+KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~m68k ~mips ppc ppc64 s390 sparc 
x86 ~amd64-linux ~x86-linux"
+IUSE="static-libs utils"
+
+RDEPEND=">=sys-libs/ncurses-5.9-r3:0=[${MULTILIB_USEDEP}]"
+DEPEND="${RDEPEND}
+       virtual/pkgconfig"
+
+S=${WORKDIR}/${MY_P}
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-5.0-no_rpath.patch
+       "${FILESDIR}"/${PN}-6.2-rlfe-tgoto.patch #385091
+       "${FILESDIR}"/${PN}-6.3-fix-long-prompt-vi-search.patch
+       "${FILESDIR}"/${PN}-6.3-read-eof.patch
+)
+
+src_unpack() {
+       unpack ${MY_P}.tar.gz
+}
+
+src_prepare() {
+       [[ ${PLEVEL} -gt 0 ]] && epatch $(patches -s)
+       epatch "${PATCHES[@]}"
+
+       # Force ncurses linking. #71420
+       # Use pkg-config to get the right values. #457558
+       local ncurses_libs=$($(tc-getPKG_CONFIG) ncurses --libs)
+       sed -i \
+               -e "/^SHLIB_LIBS=/s:=.*:='${ncurses_libs}':" \
+               support/shobj-conf || die
+       sed -i \
+               -e "/^[[:space:]]*LIBS=.-lncurses/s:-lncurses:${ncurses_libs}:" 
\
+               examples/rlfe/configure || die
+
+       # fix building under Gentoo/FreeBSD; upstream FreeBSD deprecated
+       # objformat for years, so we don't want to rely on that.
+       sed -i -e '/objformat/s:if .*; then:if true; then:' support/shobj-conf 
|| die
+
+       ln -s ../.. examples/rlfe/readline # for local readline headers
+}
+
+src_configure() {
+       # fix implicit decls with widechar funcs
+       append-cppflags -D_GNU_SOURCE
+       # https://lists.gnu.org/archive/html/bug-readline/2010-07/msg00013.html
+       append-cppflags -Dxrealloc=_rl_realloc -Dxmalloc=_rl_malloc 
-Dxfree=_rl_free
+
+       # Make sure configure picks a better ar than `ar`. #484866
+       export ac_cv_prog_AR=$(tc-getAR)
+
+       # Force the test since we used sed above to force it.
+       export bash_cv_termcap_lib=ncurses
+
+       # Control cross-compiling cases when we know the right answer.
+       # In cases where the C library doesn't support wide characters, readline
+       # itself won't work correctly, so forcing the answer below should be OK.
+       if tc-is-cross-compiler ; then
+               export bash_cv_func_sigsetjmp='present'
+               export bash_cv_func_ctype_nonascii='yes'
+               export bash_cv_wcwidth_broken='no' #503312
+       fi
+
+       # This is for rlfe, but we need to make sure LDFLAGS doesn't change
+       # so we can re-use the config cache file between the two.
+       append-ldflags -L.
+
+       multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+       ECONF_SOURCE=${S} \
+       econf \
+               --cache-file="${BUILD_DIR}"/config.cache \
+               --docdir='$(datarootdir)'/doc/${PF} \
+               --with-curses \
+               $(use_enable static-libs static)
+
+       if use utils && multilib_is_native_abi && ! tc-is-cross-compiler ; then
+               # code is full of AC_TRY_RUN()
+               mkdir -p examples/rlfe || die
+               cd examples/rlfe || die
+               ECONF_SOURCE=${S}/examples/rlfe \
+               econf --cache-file="${BUILD_DIR}"/config.cache
+       fi
+}
+
+multilib_src_compile() {
+       emake
+
+       if use utils && multilib_is_native_abi && ! tc-is-cross-compiler ; then
+               # code is full of AC_TRY_RUN()
+               cd examples/rlfe || die
+               local l
+               for l in readline history ; do
+                       ln -s ../../shlib/lib${l}$(get_libname)* 
lib${l}$(get_libname)
+                       ln -sf ../../lib${l}.a lib${l}.a
+               done
+               emake
+       fi
+}
+
+multilib_src_install() {
+       default
+
+       if multilib_is_native_abi ; then
+               gen_usr_ldscript -a readline history #4411
+
+               if use utils && ! tc-is-cross-compiler; then
+                       dobin examples/rlfe/rlfe
+               fi
+       fi
+}
+
+multilib_src_install_all() {
+       einstalldocs
+       dodoc USAGE
+       dohtml -r doc/.
+       docinto ps
+       dodoc doc/*.ps
+}
+
+pkg_preinst() {
+       preserve_old_lib /$(get_libdir)/lib{history,readline}.so.{4,5} #29865
+}
+
+pkg_postinst() {
+       preserve_old_lib_notify /$(get_libdir)/lib{history,readline}.so.{4,5}
+}

diff --git a/sys-libs/readline/readline-7.0_p5-r1.ebuild 
b/sys-libs/readline/readline-7.0_p5-r1.ebuild
new file mode 100644
index 00000000000..00c928489ec
--- /dev/null
+++ b/sys-libs/readline/readline-7.0_p5-r1.ebuild
@@ -0,0 +1,174 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit flag-o-matic multilib-minimal toolchain-funcs preserve-libs 
usr-ldscript
+
+# Official patches
+# See ftp://ftp.cwru.edu/pub/bash/readline-7.0-patches/
+PLEVEL="${PV##*_p}"
+MY_PV="${PV/_p*}"
+MY_PV="${MY_PV/_/-}"
+MY_P="${PN}-${MY_PV}"
+[[ ${PV} != *_p* ]] && PLEVEL=0
+patches() {
+       [[ ${PLEVEL} -eq 0 ]] && return 1
+       local opt=$1
+       eval set -- {1..${PLEVEL}}
+       set -- $(printf "${PN}${MY_PV/\.}-%03d " "$@")
+       if [[ ${opt} == -s ]] ; then
+               echo "${@/#/${DISTDIR}/}"
+       else
+               local u
+               for u in ftp://ftp.cwru.edu/pub/bash mirror://gnu/${PN} ; do
+                       printf "${u}/${PN}-${MY_PV}-patches/%s " "$@"
+               done
+       fi
+}
+
+DESCRIPTION="Another cute console display library"
+HOMEPAGE="https://tiswww.case.edu/php/chet/readline/rltop.html";
+
+case ${PV} in
+       *_alpha*|*_beta*|*_rc*)
+               SRC_URI+=" ftp://ftp.cwru.edu/pub/bash/${MY_P}.tar.gz";
+       ;;
+       *)
+               SRC_URI="mirror://gnu/${PN}/${MY_P}.tar.gz $(patches)"
+       ;;
+esac
+
+LICENSE="GPL-3"
+SLOT="0/7"  # subslot matches SONAME major
+KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~m68k ~mips ppc ppc64 ~riscv s390 
sparc x86 ~amd64-linux ~x86-linux"
+IUSE="static-libs +unicode utils"
+
+RDEPEND=">=sys-libs/ncurses-5.9-r3:0=[static-libs?,unicode?,${MULTILIB_USEDEP}]"
+DEPEND="${RDEPEND}
+       virtual/pkgconfig"
+
+S=${WORKDIR}/${MY_P}
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-5.0-no_rpath.patch
+       "${FILESDIR}"/${PN}-6.2-rlfe-tgoto.patch #385091
+       "${FILESDIR}"/${PN}-7.0-headers.patch
+       "${FILESDIR}"/${PN}-7.0-missing-echo-proto.patch
+       "${FILESDIR}"/${PN}-7.0-mingw.patch
+)
+
+# Needed because we don't want the patches being unpacked
+# (which emits annoying and useless error messages)
+src_unpack() {
+       unpack ${MY_P}.tar.gz
+}
+
+src_prepare() {
+       [[ ${PLEVEL} -gt 0 ]] && eapply -p0 $(patches -s)
+       default
+
+       # Force ncurses linking. #71420
+       # Use pkg-config to get the right values. #457558
+       local ncurses_libs=$($(tc-getPKG_CONFIG) ncurses$(usex unicode w '') 
--libs)
+       sed -i \
+               -e "/^SHLIB_LIBS=/s:=.*:='${ncurses_libs}':" \
+               support/shobj-conf || die
+       sed -i \
+               -e "/^[[:space:]]*LIBS=.-lncurses/s:-lncurses:${ncurses_libs}:" 
\
+               examples/rlfe/configure || die
+
+       # fix building under Gentoo/FreeBSD; upstream FreeBSD deprecated
+       # objformat for years, so we don't want to rely on that.
+       sed -i -e '/objformat/s:if .*; then:if true; then:' support/shobj-conf 
|| die
+
+       ln -s ../.. examples/rlfe/readline || die # for local readline headers
+}
+
+src_configure() {
+       # fix implicit decls with widechar funcs
+       append-cppflags -D_GNU_SOURCE
+       # https://lists.gnu.org/archive/html/bug-readline/2010-07/msg00013.html
+       append-cppflags -Dxrealloc=_rl_realloc -Dxmalloc=_rl_malloc 
-Dxfree=_rl_free
+
+       # Make sure configure picks a better ar than `ar`. #484866
+       export ac_cv_prog_AR=$(tc-getAR)
+
+       # Force the test since we used sed above to force it.
+       export bash_cv_termcap_lib=ncurses
+
+       # Control cross-compiling cases when we know the right answer.
+       # In cases where the C library doesn't support wide characters, readline
+       # itself won't work correctly, so forcing the answer below should be OK.
+       if tc-is-cross-compiler ; then
+               use kernel_Winnt || export bash_cv_func_sigsetjmp='present'
+               export bash_cv_func_ctype_nonascii='yes'
+               export bash_cv_wcwidth_broken='no' #503312
+       fi
+
+       # This is for rlfe, but we need to make sure LDFLAGS doesn't change
+       # so we can re-use the config cache file between the two.
+       append-ldflags -L.
+
+       multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+       local myeconfargs=(
+               --cache-file="${BUILD_DIR}"/config.cache
+               --with-curses
+               $(use_enable static-libs static)
+       )
+       ECONF_SOURCE="${S}" econf "${myeconfargs[@]}"
+
+       if use utils && multilib_is_native_abi && ! tc-is-cross-compiler ; then
+               # code is full of AC_TRY_RUN()
+               mkdir -p examples/rlfe || die
+               cd examples/rlfe || die
+               ECONF_SOURCE="${S}"/examples/rlfe \
+               econf --cache-file="${BUILD_DIR}"/config.cache
+       fi
+}
+
+multilib_src_compile() {
+       emake
+
+       if use utils && multilib_is_native_abi && ! tc-is-cross-compiler ; then
+               # code is full of AC_TRY_RUN()
+               cd examples/rlfe || die
+               local l
+               for l in readline history ; do
+                       ln -s ../../shlib/lib${l}$(get_libname)* 
lib${l}$(get_libname) || die
+                       ln -s ../../lib${l}.a lib${l}.a || die
+               done
+               emake
+       fi
+}
+
+multilib_src_install() {
+       default
+
+       if multilib_is_native_abi ; then
+               gen_usr_ldscript -a readline history #4411
+
+               if use utils && ! tc-is-cross-compiler; then
+                       dobin examples/rlfe/rlfe
+               fi
+       fi
+}
+
+multilib_src_install_all() {
+       HTML_DOCS="doc/history.html doc/readline.html doc/rluserman.html" 
einstalldocs
+       dodoc USAGE
+       docinto ps
+       dodoc doc/*.ps
+}
+pkg_preinst() {
+       # bug #29865
+       # Reappeared in #595324 with paludis so keeping this for now...
+       preserve_old_lib /$(get_libdir)/lib{history,readline}.so.{4,5,6}
+}
+
+pkg_postinst() {
+       preserve_old_lib_notify /$(get_libdir)/lib{history,readline}.so.{4,5,6}
+}

Reply via email to